'FFSubmenu=Effekte
'FFName=Web-Schatten

'FFSkriptName=\WebSchatten.vbs
'FFSkriptArchiv=\WebSchatten.zip
'FFSkriptDirectory=\MeckiScript\WebSchatten
'FFSkriptFiles=\MeckiScript\TempBild.jpg
'FFScriptProfile=FF_WebSchatten

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=4.02
'FFSkriptURL=http://www.ffsf.de/resources/webschatten.172/
'FFVersionMin=3.10.0

'************************************************************************
'WebSchatten.vbs (Skript fr FixFoto)
'
'Funktion:	Bilder mit Schatten versehen und auf die vorgegebene
'			maximal Kantenlnge skalieren fr Web-Verffentlichungen
'************************************************************************
' Version 4.04 vom 09.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 4.03 vom 20.01.2013	- Updateroutine aktualisiert
' Version 4.02 vom 16.05.2012	- Erzeugung des 'Schatten innen' komplett gendert,
'								  Transparenz statt Helligkeit und ergnzt um Schattenfarbe
' Version 4.01 vom 14.05.2012	- Bug bei grerem Rand mit 'Schatten innen' beseitigt
' Version 4.00 vom 11.05.2012	- Schatten innen
' Version 3.06 vom 18.04.2012	- Randberechnungen aktiver Option 'Nur verkleinern' gendert
'								- Updatefunktion auf den neuesten Stand gebracht
' Version 3.05 vom 15.02.2012	- Stackfehler behoben
'								- Updatefunktion hinzugefgt
' Version 3.04 vom 14.02.2012	- Bug mit Versionsabfrage fr Tooltip abgefangen
' Version 3.04 vom 22.01.2012	- Bug beim Seitenverhltnis beseitigt
'								- auch ggf. skalieren bei Abwahl der Schattenparameter
' Version 3.02 vom 20.01.2012	- Hintergrunderweiterung in Promille hinzu
' Version 3.01 vom 19.12.2011	- eintragen der FTP-Daten aus FixFoto per Knopfdruck
' Version 3.00 vom 05.12.2011	- Schattenlage whlbar
'								- Schattengre bei kleinen Bildern etwas angepasst
' Version 2.09 vom 30.11.2011	- Schrfe bei Option 'nur verkleinern' verbessert
' Version 2.08 vom 27.11.2011	- Bug beim Bild laden beseitigt
' Version 2.07 vom 24.11.2011	- bei Auswahl 'aktives Bild' wird
'									- die Zwischenspeicherung durch Stackoperationen ersetzt
'									- und bei lngste Seite Ist kleiner als Soll und
'										'Nur Verkleinern' aktiv auf Skalierung komplett verzichtet
' Version 2.06 vom 21.11.2011	- Skalierung bei Randstrke > 0 entfllt
'								- Dateierweiterung JPEG in die Filterliste bernommen
'								- Tooltips ab FF 2.31.06
' Version 2.05 vom 29.07.2011	- Schattenbreiten nochmals angepasst
'								- Speicheroption 'nur verkleinern' hinzu
'								- bei zu kleinen Bildern und 'nur verkleinern' aktiv
'									erfolgt eine Neuberechnung zur unskalierten Darstellung
' Version 2.04 vom 27.07.2011	- Schattenbreiten optimiert
'								- Serverpfad wird bei Eingabe bereinigt um "/"
'								- Serverpfad mit mereren Ebenen anlegen
'								- Abfrage ob hochskaliert werden soll, wenn Bild
'									kleiner als die 'lngste Seite' vorgibt.
' Version 2.03 vom 23.07.2011	- 'minimierter Hintergrund' optimiert
' Version 2.02 vom 23.07.2011	- Bug bei 'aktivem Bild' und 'kein Bild geladen' beseitigt
' Version 2.01 vom 22.07.2011	- berarbeitete Kurzbeschreibung
'								- Option 'Hintergrundgre minimiert'
'								- Schattenparameter deaktivierbar
' Version 2.00 vom 21.07.2011	- Erweitert um:
'									Auswahl (akt. Bild / sel. Bilder)
'									Speicheroptionen (Schrfen / Metadaten lschen)
'									Neuer Name mit Nummerierung (optional)
'									Speicherqualit whlbar
'									Speicherort und / oder Webablage (optional)
'									Protokollanzeige (optional)
'								- Gendert: Hinweis auf 'Immer Dialog anzeigen'
' Version 1.01 vom 11.07.2011	- Farbwahl fr Rand ermglicht
' Version 1.00 vom 07.07.2011	- Betaversion
'************************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "4.03"
const SkriptURL = "http://www.ffsf.de/resources/webschatten.172/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'Konstanten fr die Forenwerte
const FFF_lSeite = 1024					'FF-Forenwert lngste Seite - manuell gendert am 7.8.13
const FFF_HGdFarbe = "245 245 245"		'FF-Forenwert Hintergrundfarbe

'Faktoren fr die Randbreiten
'grere Werte bis 1 vergrern die Randbreiten
const Sfaktor = .5	'fr die Schattenbreite (Standard .5)
const Ufaktor = .2	'fr die Unschrfenbreite (Standard .2)

'brige Konstanten
Const BildFilter = ":BMP:JP2:JPG:JPEG:PNG:TIF:"
const RGB_S = true : const Y_S = false
const Schaerfegrade = "schwach/mittel/stark"
const S_schwach = 20 : const S_mittel = 30 : const S_stark = 40
const NummFortsetzend = true	'false bedeute, dass bei "Neuer Name + Nummer" die Nummerierung nicht fortgesetzt wird

const SkriptName = "WebSchatten.vbs"	'Skriptname
const RegSchluessel = "FF_WebSchatten"	'Registryschlssel

Dim fso,WshShell
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim SkriptKill,Antwort,Tempfile,Abbruch
SkriptKill = false : Abbruch = false

Dim Array,element,Bilder,n,b,img,strExtension
Dim Anz_shd,Anz_web,Anz_lks

'Auswahl
Dim Auswahl
'Speicheroptione
Dim flag_Schaerfen,SchaerfeWert,flag_EI_loeschen,flag_NurVerkleinern
'Speicherqualitt
Dim Qualitaet
'Name Neu
Dim flag_Umbenennen,NameNeu
'Speicherort
Dim Zielordner
'Webablage
Dim flag_WebAblage,flag_LinkSpeichern,flag_LinkVBcode

'Gre- und Schattenparameter
const SLage = "oben links/oben rechts/unten rechts/unten links/rundherum"
Dim SchLage
Dim flag_shdParam,Bist,Hist,SVist
Dim lSeite,UR_lSeite,SchStaerke,RandStaerke,SchFarbe,HGdFarbe,HgdArray,RdFarbe,RdArray,UnschFaktor,Unschaerfe
Dim flag_shdParam_I,SchLage_I,SchStaerke_I,SchTrans_I,UnschFaktor_I,SchFarbe_I,SchFArray_I		'Schatten innen
Dim Srand,Urand,Erand,Bskal,Hskal,Rand,SchRfarbe,Bild,HgErw

Dim shd_Suffix
const shdParamEin = "_shd" : const shdParamAus = "_skl"

'Allgemein
Dim flag_Protokoll,flag_DimmerEin,flag_HGmin

'FTP-Funktion
const FTP_RegSchluessel = "FTP_Ablage"				'Registryschlssel
Dim FTP_file,FTP_Abbruch
Dim server,remotepath,domain,user,pwd,passiveftp,bool_pFTP
Dim FTP_Links
'------------------------------------------------------------------------
Set fso = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")
call Main
Set fso = nothing
set WshShell = nothing
'------------------------------------------------------------------------
Sub Main

on error resume next					'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'Registry auslesen
call RegistryLesen
call FTP_RegistryLesen

if Auswahl = 4 then
	if FF_GetImageWidth = 0 and flag_DimmerEin = 0 then
		if FF_CheckKey = 16 then	'Shift-Taste
			call Dialog
		else
			msgbox "Es ist kein Bild geladen!" & vbNewLine & "Daher wird der Dialog aufgerufen.",vbCritical,"Abbruch"
			call Dialog
		end if
	else
		'prfen ob beim Skriptstart eine Taste festgehalten wurde
		'und ggf. entsprechende Aktionen einleiten
		if FF_CheckKey = 16 then	'Shift-Taste
			call Dialog
		else
		
			if flag_DimmerEin = 1 then
				call Dialog
			else
				call Kontrolle
				if not Abbruch then
					call Bildschleife
				else
					call Dialog
				end if
			end if
		end if
	end if
else
	call Dialog
end if

end sub
'------------------------------------------------------------------------
Sub Schattenerzeugung
Dim Bsoll, Hsoll, Hrand

'### Berechnungen
'Randbreiten ermitteln
Srand = round(lSeite * SchStaerke  / 100 * SFaktor)	'Schatten-Rand
Urand = round(lSeite * UnschFaktor / 100 * Ufaktor)	'Unschrfe-Rand

if flag_HGmin = 0 then
	Erand = Urand							'Erweiterungsrand
else
	Erand = 0
end if

if flag_HGmin = 0 then
	Hrand = round(lSeite * HgErw / 1000)	'Hintergrundrand
else
	Hrand = 0
end if

'skalierte Werte in Breite und Hhe fr Schatten- und Originalbild
if Bist >= Hist then
	Bskal = lSeite - (Srand + Urand + Erand) - 2* Hrand
	Hskal = round(Bskal / SVist)   
else
	Hskal = lSeite - (Srand + Urand + Erand) - 2* Hrand
	Bskal = round(Hskal * SVist)
end if

Bsoll = Bskal : Hsoll = Hskal

if flag_NurVerkleinern = 1 and Bist < Bskal and Hist < Hskal then	'### Neuberechnung

	if Bist >= Hist then lSeite = Bist else lSeite = Hist
	
	Srand = round(SchStaerke  / 100 * SFaktor * lSeite)	'Faktor Schatten-Rand
	Urand = round(UnschFaktor / 100 * Ufaktor * lSeite)	'Faktor Unschrfe-Rand
	
	if flag_HGmin = 0 then
		Erand = Urand							'Erweiterungsrand
	else
		Erand = 0
	end if

	if flag_HGmin = 0 then
		Hrand = round(lSeite * HgErw / 1000)	'Hintergrundrand
	else
		Hrand = 0
	end if

	Bskal = Bist 	'+ Srand + Urand - Erand  (gendert in 3.06)
	Hskal = Hist 	'+ Srand + Urand - Erand  (gendert in 3.06)
	Bsoll = Bist : Hsoll = Hist

end if

'### Neues Bild (Schattengrundlage)
FF_NewImage Bskal,Hskal,SchRfarbe

Select Case SchLage
	case "oben links"
		'### Schattenbild erzeugen
		FF_ExtendCanvas Urand,Srand + Erand,Urand,Srand + Erand,HgdArray(0),HgdArray(1),HgdArray(2)
		FF_HamiltonSharp 256,Unschaerfe		'weich zeichnen
		'### Originalbild einkopieren
		FF_SwapImage						'Schattenbild in den Stack + Original nach oben
		FF_MixImage Bskal - Bsoll + Srand + Urand,Bskal - Bsoll + Srand + Urand,Bsoll,Hsoll,256
	case "oben rechts"
		'### Schattenbild erzeugen
		FF_ExtendCanvas Srand + Erand,Urand,Urand,Srand + Erand,HgdArray(0),HgdArray(1),HgdArray(2)
		FF_HamiltonSharp 256,Unschaerfe		'weich zeichnen
		'### Originalbild einkopieren
		FF_SwapImage						'Schattenbild in den Stack + Original nach oben
		FF_MixImage Erand,Hskal - Hsoll + Srand + Urand,Bsoll,Hsoll,256
	case "unten rechts"
		'### Schattenbild erzeugen
		FF_ExtendCanvas Srand + Erand,Urand,Srand + Erand,Urand,HgdArray(0),HgdArray(1),HgdArray(2)
		FF_HamiltonSharp 256,Unschaerfe		'weich zeichnen
		'### Originalbild einkopieren
		FF_SwapImage						'Schattenbild in den Stack + Original nach oben
		FF_MixImage Erand,Erand,Bsoll,Hsoll,256
	case "unten links"
		'### Schattenbild erzeugen
		FF_ExtendCanvas Urand,Srand + Erand,Srand + Erand,Urand,HgdArray(0),HgdArray(1),HgdArray(2)
		FF_HamiltonSharp 256,Unschaerfe		'weich zeichnen
		'### Originalbild einkopieren
		FF_SwapImage						'Schattenbild in den Stack + Original nach oben
		FF_MixImage Bskal - Bsoll + Srand + Urand,Erand,Bsoll,Hsoll,256
End select

'### fertiges Bild zurck holen, mit Hintergrunderweiterung versehen und zhlen
FF_PopImage				'Fertiges Bild mit Schatten aus dem Stack holen
FF_ExtendCanvas Hrand,Hrand,Hrand,Hrand,HgdArray(0),HgdArray(1),HgdArray(2)
Anz_shd = Anz_shd +1	'Anzahl schattierter Bilder

End Sub
'------------------------------------------------------------------------
Sub Schattenerzeugung_mittig
Dim Hrand

'### Berechnungen
'Randbreiten ermitteln
Srand = round(lSeite * SchStaerke  / 100 * SFaktor)	'Schatten-Rand
Urand = round(lSeite * UnschFaktor / 100 * Ufaktor)	'Unschrfe-Rand
if flag_HGmin = 0 then
	Hrand = round(lSeite * HgErw / 1000)			'Hintergrundrand
else
	Hrand = 0
end if

if Bist >= Hist then
	Bskal = lSeite - 2 * Urand - 2* Hrand 
	Hskal = round(Bskal / SVist)   
else
	Hskal = lSeite - 2 * Urand - 2* Hrand 
	Bskal = round(Hskal * SVist)
end if

if flag_NurVerkleinern = 1 and Bist < Bskal and Hist < Hskal then	'### Neuberechnung

	'#### Neu
	if Bist >= Hist then lSeite = Bist else lSeite = Hist
	
	Srand = round(lSeite * SchStaerke  / 100 * SFaktor)	'Faktor Schatten-Rand
	Urand = round(lSeite * UnschFaktor / 100 * Ufaktor)	'Faktor Unschrfe-Rand

	if flag_HGmin = 0 then
		Hrand = round(lSeite * HgErw / 1000)			'Hintergrundrand
	else
		Hrand = 0
	end if

	Bskal = Bist + 2 * Srand
	Hskal = Hist + 2 * Srand

	'### Schattenbild erzeugen
	FF_NewImage Bskal,Hskal,SchRfarbe
	FF_ExtendCanvas Urand,Urand,Urand,Urand,HgdArray(0),HgdArray(1),HgdArray(2)	
	FF_HamiltonSharp 256,Unschaerfe		'weich zeichnen
	
	'### Originalbild einkopieren
	FF_SwapImage						'Schattenbild in den Stack + Original nach oben
	FF_MixImage Urand + Srand,Urand + Srand,Bist,Hist,256

else
	'### Schattenbild erzeugen
	FF_NewImage Bskal,Hskal,SchRfarbe
	FF_ExtendCanvas Urand,Urand,Urand,Urand,HgdArray(0),HgdArray(1),HgdArray(2)	

	FF_HamiltonSharp 256,Unschaerfe		'weich zeichnen
	
	'### Originalbild einkopieren
	FF_SwapImage						'Schattenbild in den Stack + Original nach oben
	FF_MixImage Urand + Srand,Urand + Srand,Bskal - 2* Srand,Hskal - 2* Srand,256
end if

'### fertiges Bild zurck holen, mit Hintergrunderweiterung versehen und zhlen
FF_PopImage				'Fertiges Bild mit Schatten aus dem Stack holen
FF_ExtendCanvas Hrand,Hrand,Hrand,Hrand,HgdArray(0),HgdArray(1),HgdArray(2)
Anz_shd = Anz_shd +1	'Anzahl schattierter Bilder

End Sub
'------------------------------------------------------------------------
Sub Schattenerzeugung_Innen
Dim Srand_I,Trans_I,Unsch_I
Dim XI,YI,BI,HI

if Rand > 0 then
	Bist = Bist - 2 * Rand
	Hist = Hist - 2 * Rand
	FF_Crop Rand,Rand,Bist,Hist
end if

if Bist > Hist then
	Srand_I = round(Bist * SchStaerke_I / 100 * SFaktor)		'Schattenstrke
else
	Srand_I = round(Hist * SchStaerke_I / 100 * SFaktor)		'Schattenstrke	
end if

Trans_I = round((11 - SchTrans_I) * 25.5)						'Transparenz (max 255 bei FF_AreaFillRect)
Unsch_I = round(UnschFaktor_I * 6.4)							'Unschrfe   (max  64 bei FF_SetArea)

FF_SetArea 0,0,0,0,false,0,Unsch_I

Select Case SchLage_I
	case "oben links"
		FF_AreaFillRect 0,0,Bist,Srand_I,Trans_I						'oben
		FF_AreaFillRect 0,0,Srand_I,Hist,Trans_I						'links
	case "oben rechts"
		FF_AreaFillRect 0,0,Bist,Srand_I,Trans_I						'oben
		FF_AreaFillRect Bist - Srand_I,0,Bist,Hist,Trans_I				'rechts
	case "unten rechts"
		FF_AreaFillRect 0,Hist - Srand_I,Bist,Hist,Trans_I				'unten
		FF_AreaFillRect Bist - Srand_I,0,Bist,Hist,Trans_I				'rechts
	case "unten links"
		FF_AreaFillRect 0,Hist - Srand_I,Bist,Hist,Trans_I				'unten
		FF_AreaFillRect 0,0,Srand_I,Hist,Trans_I						'links
	case "rundherum"
		FF_AreaFillRect 0,0,Srand_I,Hist,Trans_I						'links
		FF_AreaFillRect 0,0,Bist,Srand_I,Trans_I						'oben
		FF_AreaFillRect 0,Hist - Srand_I,Bist,Hist,Trans_I				'unten
		FF_AreaFillRect Bist - Srand_I,0,Bist,Hist,Trans_I				'rechts
End select

FF_WhiteBalance -255,-255,-255
FF_WhiteBalance SchFArray_I(0),SchFArray_I(1),SchFArray_I(2)			'Schattenfarbe
FF_SetArea 0,0,0,0,0,0,0

if Rand > 0 then FF_ExtendCanvas Rand,Rand,Rand,Rand,RdArray(0),RdArray(1),RdArray(2)

if flag_shdParam = 0 then Anz_shd = Anz_shd +1	'Anzahl schattierter Bilder

End Sub
'------------------------------------------------------------------------
'RGB-Wert ("000 000 000" bis "255 255 255") zu Farbreferenz (0 - 16777215)
Function Farbreferenz (RGB_Wert)
Dim C_Array
	C_Array = split(RGB_Wert," ")
	Farbreferenz = C_Array(0) + C_Array(1) * (2^8) + C_Array(2) * (2^16)
End Function
'------------------------------------------------------------------------
Sub Bildschleife
Dim Swert,Nr,Suffix,Nummer,pos
Dim k : k = 0
Dim MaxGelesen : MaxGelesen = false
Dim Bildname,msg,msgw,msgl

Anz_shd = 0 : Anz_web = 0 : Anz_lks = 0
FTP_Abbruch = false

'ggf. FTP-Funktion prfen
if flag_WebAblage = 1 then
	call FTP_Oeffnen
end if

if Abbruch then
	msgbox "Die Schattenbildung wird wegen Probleme" & vbNewLine & _
		   "mit der FTP-bertragung abgebrochen!" & vbNewLine & vbNewLine & _
		   "Die Probleme mssen behoben werden oder" & vbNewLine & _
		   "die Option 'Ablage auf dem Webserver' muss" & vbNewLine & _
		   "deaktiviert werden.",vbExclamation,"Abbruch"
	exit sub
end if

'Vorberechnungen fr die Schattenbildung
SchRfarbe = Farbreferenz(SchFarbe)		'Schattenfarbe Referenzwert
HgdArray = split(HgdFarbe," ")			'Hintergrundfarbe Array fr RGB-Werte
RdArray = split(RdFarbe," ")			'Randfarbe Array fr RGB-Werte
SchFArray_I = split(SchFarbe_I," ")		'Schattenfarbe Array (Schatten innen)

Unschaerfe	= round(lSeite / 300 * UnschFaktor)	'Unschrfe
if Unschaerfe > 64 then Unschaerfe = 64

'Bilder-Suffix festlegen
if flag_shdParam = 1 then
	shd_Suffix = shdParamEin
else
	shd_Suffix = shdParamAus
end if

'Bilder in Array eintragen
Array = split(Bilder, vbNewLine)
img = ubound(Array) + 1

for b = 0 to img - 1
	lSeite = UR_lSeite *1
	
	'### Bild laden
	Bild = Array(b)
	if Auswahl < 4 then
		FF_LoadImage Bild	'nicht das aktive Bild

		'### Test ob Bild vorhanden, sonst Abbruch
		if not fso.FileExists(Bild) then
			msgbox "Die Datei " & Bilder(b) & " wurde bereits gelscht" & vbNewLine & _
	  			   "Bitte die Bilder aktualisieren und es dann erneut versuchen!",vbExclamation,"Abbruch"
			exit sub
		end if
	end if

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & img & " Dateien wurden bisher " & b & _
						 " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll das Skript abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit for
	end if

	'### Fortschrittsanzeige
	if Auswahl < 4 then FF_SetControl "Web-Schatten","Fortschritt",(b+1)/img*100

	'### Bildfilter anwenden
	strExtension = ucase(fso.GetExtensionName(Array(b)))
	if strExtension <> "" and instr(BildFilter,":" & strExtension & ":") > 0 then

		'### Istwerte ermitteln
		Bist = FF_GetImageWidth() *1				'Ist-Breite
		Hist = FF_GetImageHeight() *1				'Ist-Hhe
		
		'### Randvergrerung							'hier ab ** V 2.06
		if RandStaerke > 0 then
			if Bist >= Hist then
				Rand = round(Bist * RandStaerke / 1000)		'Randstrke in px fr Bildrand
			else
				Rand = round(Hist * RandStaerke / 1000)		'Randstrke in px fr Bildrand
			end if
			if Rand < 1 then Rand = 1	'   in Hintergrundfarbe
			FF_ExtendCanvas Rand,Rand,Rand,Rand,RdArray(0),RdArray(1),RdArray(2)
		
			'### Istwerte korrigieren und Seitenverhltnis ermitteln
			Bist = Bist + 2 * Rand
			Hist = Hist + 2 * Rand
		end if

		SVist = Bist / Hist									'Istwert Seitenverhltnis

		'### Schattenerzeugung 								'Aufruf Schattenerzeugung
		if flag_shdParam_I = 1 then call Schattenerzeugung_Innen
		FF_PushImage
		if flag_shdParam = 1 then
			if SchLage = "rundherum" then
				call Schattenerzeugung_mittig
			else
				call Schattenerzeugung
			end if
		else
			if flag_NurVerkleinern = 0 or flag_NurVerkleinern = 1 and (Bist > lSeite or Hist > lSeite) then
				FF_HQScale lSeite,lSeite,true
			end if
		end if
		
		'### Speicheroptionen anwenden
		'Schrfen
		if flag_Schaerfen = 1 then
			select case SchaerfeWert
				case "schwach"
					Swert = S_schwach
				case "mittel"
					Swert = S_mittel
				case "stark"
					Swert = S_stark
			case else
				msgbox "Schwerer Schrfe-Fehler!",vbExclamation,"Abbruch"
				exit sub
			end select

			if RGB_S then FF_Sharp Swert,true,true,true
			if Y_S then FF_YSharp Swert
		end if
		
		'Metadaten lschen
		if flag_EI_loeschen = 1 then
			if FF_HasExif() then FF_KillExif
			if FF_HasIPTC() then FF_KillIPTC
		end if
		
		'Bildname aufteilen
		Bildname = fso.GetBaseName(Bild)
		strExtension = "." & strExtension

		'### ggf. umbenennen
		if Auswahl < 4 then
			if flag_Umbenennen = 1 then
				if NummFortsetzend and not MaxGelesen then			'### max. vorhandene Nummer wird ermittelt
					MaxGelesen = true
					Nummer = MaxDatei(Zielordner,NameNeu & "_")
					if Nummer = "" then
						k = 0
					else
						pos = InStrRev(Nummer,"_")
						if pos > 0 then	k = mid(Nummer,pos+1,4) else k = 0
						if IsNumeric(k) then k = k * 1 else k = 0
					end if
				end if
				Nr = k + b +1										'### Bildnummer wird festgelegt
				select case len(Nr)
					case 1
						Suffix = "_000" & Nr
					case 2
						Suffix = "_00" & Nr
					case 3
						Suffix = "_0" & Nr
					case 4
						Suffix = "_" & Nr
				case else
					msgbox "Schwerer Nummerierungs-Fehler!",vbExclamation,"Abbruch"
					exit sub
				end select

				Bildname = Zielordner & "\" & NameNeu & shd_Suffix & Suffix
			else
				Bildname = Zielordner & "\" & Bildname & shd_Suffix
			end if

			'### vorhandene Bilder nummerieren mit (1), (2) usw.
			if fso.FileExists(Bildname & strExtension) then
				n = 1
				do
					if not fso.FileExists(Bildname & "(" & n & ")" & strExtension) then exit do
					n = n + 1
				loop
				Bildname = Bildname & "(" & n & ")" & strExtension
			else
				Bildname = Bildname & strExtension
			end if

			'### Bild speichern
			FF_SaveImage Bildname,Qualitaet
		else
			FF_Reload
		end if

		'### Webablage
		if flag_WebAblage = 1 and not FTP_Abbruch then
			call FTP_Uebertragung (Bildname)
		end if

	end if
next

if flag_WebAblage = 1 and not FTP_Abbruch then
	FF_CloseFTP() 										'FTP-Verbindung schlieen
	if  flag_LinkSpeichern = 1 and Anz_lks > 0 then
		call FF_TextToClipboard(FTP_Links)				'Links in die Zwischenablage
	end if
end if

'Anzeigetext
if flag_Protokoll = 0 then exit sub

if Anz_shd = 0 then msg = "Es wurde kein Bild "
if Anz_shd = 1 then msg = "Es wurde ein Bild "
if Anz_shd > 1 then msg = "Es wurden " & Anz_shd & " Bilder "
msg = msg & "mit Schatten versehen."

if flag_WebAblage = 1 and not FTP_Abbruch and Anz_shd > 0 then
	if Anz_web = 0 then msgw = "Davon wurde kein Bild "
	if Anz_web = 1 then msgw = "Davon wurde ein Bild "
	if Anz_web > 1 then msgw = "Davon wurden " & Anz_web & " Bilder "
	msgw = vbNewline & msgw & "auf den FTP-Server bertragen."
	
	if  flag_LinkSpeichern = 1 and Anz_web > 0 then
		if Anz_lks > 0 then
			if Anz_lks = 1 then
				msgl = "Es wurde ein Link "
			else
				msgl = "Es wurden " & Anz_lks & " Links "
			end if
			msgl = msgl & "zu den im Web abgelegten Bildern" & vbNewLine & _
				   "in den Zwischenspeicher bernommen!"
		else
			msgl = "Es konnte kein Link zu den im Web abgelegten Bildern" & vbNewLine & _
				   "in den Zwischenspeicher bernommen werden!" & vbNewLine & vbNewLine & _
				   "Mglicherweise wurde in den FTP-Zugangsdaten kein" & vbNewLine & _
				   "kein Domainname angegeben."
		end if
		msgl = vbNewline & vbNewLine & msgl
	end if
end if

if len(msgw) > 0 then msg = msg & msgw
if len(msgl) > 0 then msg = msg & msgl
msgbox msg,vbInformation,"Protokoll"

End Sub
'------------------------------------------------------------------------
Function MaxDatei(OrdnerAngabe,FilterAngabe)
   Dim f,f1,fc,MBild
   Set f = fso.GetFolder(OrdnerAngabe)
   Set fc = f.Files
   For Each f1 in fc
		if instr(f1.Name,FilterAngabe) = 1 then
			if f1.Name > MBild then MBild = f1.Name
		end if
   Next
   MaxDatei = MBild
End Function
'------------------------------------------------------------------------
Sub Dialog
Dim n,Anzeige

'** Start Dialog Web-Schatten **
FF_AddDialog "Web-Schatten",433,185
FF_AddControl "Web-Schatten","Schatten innen","GROUP",326,46,104,105
FF_AddControl "Web-Schatten","Auswahl","GROUP",2,5,112,40
FF_AddControl "Web-Schatten","selAB","BOOL",7,14,8,8
FF_SetControlStyle "Web-Schatten","selAB",16384
FF_AddControl "Web-Schatten","aktives Bild auf der Arbeitsflche","STATIC",17,13,94,10
FF_AddControl "Web-Schatten","selCV","BOOL",7,24,8,8
FF_SetControlStyle "Web-Schatten","selCV",16384
FF_AddControl "Web-Schatten","markierte Bilder der Computer-Ansicht","STATIC",17,23,94,10
FF_AddControl "Web-Schatten","selBL","BOOL",7,34,8,8
FF_SetControlStyle "Web-Schatten","selBL",16384
FF_AddControl "Web-Schatten","markierte Bilder der aktiven Bilderliste","STATIC",17,33,93,10
FF_AddControl "Web-Schatten","Speicheroptionen","GROUP",118,5,94,40
FF_AddControl "Web-Schatten","flag_Schaerfen","BOOL",122,14,8,8
FF_AddControl "Web-Schatten","Schrfen","STATIC",134,13,33,10
FF_AddControl "Web-Schatten","SchaerfeWert","COMBO",164,13,33,10
FF_AddControl "Web-Schatten","flag_EI_loeschen","BOOL",122,24,8,8
FF_AddControl "Web-Schatten","Exif- und IPTC-Daten lschen","STATIC",134,23,72,10
FF_AddControl "Web-Schatten","flag_NurVerkleinern","BOOL",122,34,8,8
FF_AddControl "Web-Schatten","nur verkleinern","STATIC",134,34,72,10
FF_AddControl "Web-Schatten","Neuer Name + Nummer","GROUP",2,48,112,26
FF_AddControl "Web-Schatten","flag_Umbenennen","BOOL",94,47,8,9
FF_AddControl "Web-Schatten","NameNeu","SLEDIT",7,58,102,10
FF_AddControl "Web-Schatten","Speicherqualitt","GROUP",118,48,94,26
FF_AddControl "Web-Schatten","Qualitaet","SLEDIT",122,58,20,10
FF_SetControlStyle "Web-Schatten","Qualitaet",8193
FF_AddControl "Web-Schatten","60-100% (0 = FF-Einst.)","STATIC",147,58,62,10
FF_AddControl "Web-Schatten","Speicherort","GROUP",2,77,210,35
FF_AddControl "Web-Schatten","zur Ablage markierter Bilder nach Schattenerzeugung","STATIC",7,85,158,10
FF_AddControl "Web-Schatten","Zielordner","SLEDIT",7,98,180,10
FF_SetControlStyle "Web-Schatten","Zielordner",2048
FF_AddControl "Web-Schatten","...","BUTTON",193,97,14,11
FF_AddControl "Web-Schatten","Web-Ablage","GROUP",2,114,210,36
FF_AddControl "Web-Schatten","flag_WebAblage","BOOL",7,124,8,8
FF_SetControlStyle "Web-Schatten","flag_WebAblage",16384
FF_AddControl "Web-Schatten","Ablage auf einem FTP-Server","STATIC",17,123,75,10
FF_AddControl "Web-Schatten","FTP-Zugangsdaten","BUTTON",27,134,50,11
FF_AddControl "Web-Schatten","flag_LinkSpeichern","BOOL",97,124,8,8
FF_AddControl "Web-Schatten","Link(s) bernehmen in die Zwischenablage","STATIC",107,123,100,10
FF_AddControl "Web-Schatten","flag_LinkVBcode","BOOL",108,136,8,8
FF_AddControl "Web-Schatten","mit vb-Code [img] ... [/img]","STATIC",118,135,72,10
FF_AddControl "Web-Schatten","Bildgre und Rand","GROUP",217,5,213,36
FF_AddControl "Web-Schatten","lngste Seite","STATIC",223,13,40,10
FF_AddControl "Web-Schatten","lSeite","SLEDIT",269,13,28,10
FF_SetControlStyle "Web-Schatten","lSeite",8193
FF_AddControl "Web-Schatten","px","STATIC",302,13,10,10
FF_AddControl "Web-Schatten","Schatten auen","GROUP",217,45,104,105
FF_AddControl "Web-Schatten","flag_shdParam","BOOL",304,44,8,8
FF_SetControlStyle "Web-Schatten","flag_shdParam",16384
FF_AddControl "Web-Schatten","Schattenlage","STATIC",223,59,40,10
FF_AddControl "Web-Schatten","SchLage","COMBO",272,59,44,10
FF_AddControl "Web-Schatten","Schattenstrke","STATIC",223,71,40,10
FF_AddControl "Web-Schatten","SchStaerke","COMBO",272,71,28,10
FF_AddControl "Web-Schatten","%","STATIC",306,71,10,10
FF_AddControl "Web-Schatten","Schattenfarbe","STATIC",223,83,40,10
FF_AddControl "Web-Schatten","SchFarbe","COLOR",272,83,44,10
FF_AddControl "Web-Schatten","Unschrfefaktor","STATIC",223,95,40,10
FF_AddControl "Web-Schatten","UnschFaktor","COMBO",272,95,28,10
FF_AddControl "Web-Schatten","Hintergrundfarbe","STATIC",223,110,42,10
FF_AddControl "Web-Schatten","HGdFarbe","COLOR",272,109,44,10
FF_AddControl "Web-Schatten","Hintergr.-Erweiter.","STATIC",223,122,45,10
FF_AddControl "Web-Schatten","HgErw","SLEDIT",272,122,28,10
FF_SetControlStyle "Web-Schatten","HgErw",8193
FF_AddControl "Web-Schatten","|","STATIC",306,122,11,10
FF_AddControl "Web-Schatten","flag_HGmin","BOOL",233,137,8,8
FF_SetControlStyle "Web-Schatten","flag_HGmin",16384
FF_AddControl "Web-Schatten","Hintergrund minimieren","STATIC",244,135,60,11
FF_AddControl "Web-Schatten","FF-Forenwerte","BUTTON",244,26,48,10
FF_AddControl "Web-Schatten","Randstrke","STATIC",328,13,42,10
FF_AddControl "Web-Schatten","RandStaerke","COMBO",379,13,28,10
FF_AddControl "Web-Schatten","","STATIC",411,12,11,10
FF_AddControl "Web-Schatten","Randfarbe","STATIC",328,25,27,10
FF_AddControl "Web-Schatten","= HGF","BUTTON",356,25,20,10
FF_AddControl "Web-Schatten","RdFarbe","COLOR",379,25,44,10
FF_AddControl "Web-Schatten","Fortschritt","PROGRESS",3,155,426,4
FF_AddControl "Web-Schatten","?","BUTTON",5,167,11,11
FF_AddControl "Web-Schatten","Update","BUTTON",43,167,33,11
FF_AddControl "Web-Schatten","Unterbrechen mit","STATIC",106,167,43,11
FF_AddControl "Web-Schatten","Backspace","BUTTON",149,168,30,9
FF_AddControl "Web-Schatten","-Taste","STATIC",180,167,16,11
FF_AddControl "Web-Schatten","flag_Protokoll","BOOL",236,163,8,8
FF_SetControlStyle "Web-Schatten","flag_Protokoll",16384
FF_AddControl "Web-Schatten","Protokoll automatisch anzeigen","STATIC",246,162,80,10
FF_AddControl "Web-Schatten","flag_DimmerEin","BOOL",236,173,8,8
FF_SetControlStyle "Web-Schatten","flag_DimmerEin",16384
FF_AddControl "Web-Schatten","vorliegenden Dialog immer zeigen","STATIC",246,172,80,10
FF_AddControl "Web-Schatten","Abbrechen","BUTTON",370,167,33,11
FF_AddControl "Web-Schatten","OK","BUTTON",407,167,14,11
FF_AddControl "Web-Schatten","&delete","BUTTON",2,2,1,1
FF_AddControl "Web-Schatten","|","STATIC",18,167,24,11
FF_SetControlStyle "Web-Schatten","|",1
FF_AddControl "Web-Schatten","Schattenlage|","STATIC",332,59,40,10
FF_AddControl "Web-Schatten","flag_shdParam_I","BOOL",414,44,8,8
FF_SetControlStyle "Web-Schatten","flag_shdParam_I",16384
FF_AddControl "Web-Schatten","SchLage_I","COMBO",379,59,44,10
FF_AddControl "Web-Schatten","Schattenstrke|","STATIC",332,71,40,10
FF_AddControl "Web-Schatten","SchStaerke_I","COMBO",379,71,28,10
FF_AddControl "Web-Schatten","%|","STATIC",416,71,10,10
FF_AddControl "Web-Schatten","Unschrfefaktor|","STATIC",332,95,40,10
FF_AddControl "Web-Schatten","UnschFaktor_I","COMBO",379,95,28,10
FF_AddControl "Web-Schatten","Transparenz","STATIC",332,109,40,10
FF_AddControl "Web-Schatten","SchTrans_I","COMBO",379,109,28,10
FF_AddControl "Web-Schatten","Bei 'Schatten innen' ist das","STATIC",344,123,65,10
FF_SetControlStyle "Web-Schatten","Bei 'Schatten innen' ist das",1
FF_AddControl "Web-Schatten","Bild der Hintergrund","STATIC",344,134,65,10
FF_SetControlStyle "Web-Schatten","Bild der Hintergrund",1
FF_AddControl "Web-Schatten","Schattenfarbe|","STATIC",332,83,40,10
FF_AddControl "Web-Schatten","SchFarbe_I","COLOR",379,83,44,10
'** End Dialog Web-Schatten **

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Web-Schatten","Zielordner",Zielordner
	FF_SetControlTooltip "Web-Schatten","NameNeu", "" &_
						 "An den eingegebenen Namen wird" & vbNewLine & "die Erweiterung '_shd' und eine" & vbNewLine &_
						 "vierstellige Nummer angehngt."
	FF_SetControlTooltip "Web-Schatten","Qualitaet", "" &_
						 "Qualitt der einzufgenden Bilder." & vbNewLine & "Bei 0 wird die FixFoto-Einstellung verwendet."
	FF_SetControlTooltip "Web-Schatten","lSeite", "" &_
						 "Lngste Seite des fertigen Bildes." & vbNewLine & "Wenn 'nur verkleinern' aktiviert und" & vbNewLine &_
						 "das zu bearbeitende Bild kleiner ist," & vbNewLine & "wird dieser Wert begrenzt."
	FF_SetControlTooltip "Web-Schatten","= HGF", "" &_
						 "Fr die Randfarbe wird die" & vbNewLine & "Hintergrundfarbe bernommen."
	FF_SetControlTooltip "Web-Schatten","FTP-Zugangsdaten", "" &_
						 "ffnen einer Maske" & vbNewLine & "zur Eingabe der FTP-Daten."
	FF_SetControlTooltip "Web-Schatten","FF-Forenwerte", "" &_
						 "Zur Verffentlichung im FixFoto-Forum" & vbNewLine & "werden eingetragen:" & vbNewLine &_
						 "lngste Seite = 800 px" & vbNewLine & "Hintergrundfarbe = Forenhintergrund"
	FF_SetControlTooltip "Web-Schatten","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & "vorausgesetzt es ist ein PDF-Reader installiert."
	FF_SetControlTooltip "Web-Schatten","Backspace", "" &_
					 	 "Vorzeitiger Abbruch mglich durch" & vbNewLine & "festhalten der 'Backspace'-Taste bis" & vbNewLine &_
						 "eine Rckmeldung erfolgt."
end if

'Vorgabewerte Schrfegrade
Array = split(Schaerfegrade,"/")
for each element in Array
	FF_SetControl "Web-Schatten","SchaerfeWert",element
next

'Vorgabewerte Schattenparameter eintragen
Array = split(SLage,"/")
for each element in Array : FF_SetControl "Web-Schatten","SchLage",element : next
for each element in Array : FF_SetControl "Web-Schatten","SchLage_I",element : next
for n = 1 to 10 : FF_SetControl "Web-Schatten","SchStaerke",n  : next
for n = 1 to 10 : FF_SetControl "Web-Schatten","SchStaerke_I",n  : next
for n = 1 to 10 : FF_SetControl "Web-Schatten","SchTrans_I",n  : next
for n = 1 to 10 : FF_SetControl "Web-Schatten","UnschFaktor",n : next
for n = 1 to 10 : FF_SetControl "Web-Schatten","UnschFaktor_I",n : next
for n = 0 to 10 : FF_SetControl "Web-Schatten","RandStaerke",n : next
for n = 15 to 30 step 5 : FF_SetControl "Web-Schatten","RandStaerke",n : next

'### Registrywerte eintragen

'Auswahl
select case Auswahl
	Case 4
		FF_SetControl "Web-Schatten","selAB",1
	Case 1
		FF_SetControl "Web-Schatten","selCV",1
	Case 3
		FF_SetControl "Web-Schatten","selBL",1
Case else
End select

'Speicheroptionen
FF_SetControl "Web-Schatten","flag_Schaerfen",flag_Schaerfen
FF_SetControl "Web-Schatten","SchaerfeWert",SchaerfeWert
FF_SetControl "Web-Schatten","flag_EI_loeschen",flag_EI_loeschen
FF_SetControl "Web-Schatten","flag_NurVerkleinern",flag_NurVerkleinern

'Neuer Name + Nummer
FF_SetControl "Web-Schatten","flag_Umbenennen",flag_Umbenennen
FF_SetControl "Web-Schatten","NameNeu",NameNeu

'Speicherqualitt
FF_SetControl "Web-Schatten","Qualitaet",Qualitaet

'Speicherort
FF_SetControl "Web-Schatten","Zielordner",Zielordner

'Webablage
FF_SetControl "Web-Schatten","flag_WebAblage",flag_WebAblage
FF_SetControl "Web-Schatten","flag_LinkSpeichern",flag_LinkSpeichern
FF_SetControl "Web-Schatten","flag_LinkVBcode",flag_LinkVBcode

'Bildgre und Schattenwerte
FF_SetControl "Web-Schatten","flag_shdParam",flag_shdParam
FF_SetControl "Web-Schatten","SchLage",SchLage
FF_SetControl "Web-Schatten","lSeite",lSeite
FF_SetControl "Web-Schatten","flag_shdParam",flag_shdParam
FF_SetControl "Web-Schatten","SchStaerke",SchStaerke
FF_SetControl "Web-Schatten","SchFarbe",SchFarbe
FF_SetControl "Web-Schatten","UnschFaktor",UnschFaktor
FF_SetControl "Web-Schatten","HGdFarbe",HGdFarbe
FF_SetControl "Web-Schatten","HgErw",HgErw
FF_SetControl "Web-Schatten","flag_HGmin",flag_HGmin
FF_SetControl "Web-Schatten","RandStaerke",RandStaerke
FF_SetControl "Web-Schatten","RdFarbe",RdFarbe

FF_SetControl "Web-Schatten","flag_shdParam_I",flag_shdParam_I
FF_SetControl "Web-Schatten","SchLage_I",SchLage_I
FF_SetControl "Web-Schatten","SchStaerke_I",SchStaerke_I
FF_SetControl "Web-Schatten","SchTrans_I",SchTrans_I
FF_SetControl "Web-Schatten","UnschFaktor_I",UnschFaktor_I
FF_SetControl "Web-Schatten","SchFarbe_I",SchFarbe_I

'Allgemein
FF_SetControl "Web-Schatten","flag_Protokoll",flag_Protokoll
FF_SetControl "Web-Schatten","flag_DimmerEin",flag_DimmerEin

'Fokus auf delete und Timeraktivierung
FF_ActivateControl "Web-Schatten","&delete"
FF_SetDialogTimer "Web-Schatten", 100

do

'Diverses disablen
if Auswahl = 4 then
	FF_EnableControl "Web-Schatten","flag_Umbenennen", false
	FF_EnableControl "Web-Schatten","NameNeu", false
	FF_EnableControl "Web-Schatten","Zielordner", false
	FF_EnableControl "Web-Schatten","...", false
else
	FF_EnableControl "Web-Schatten","flag_Umbenennen",true
	FF_EnableControl "Web-Schatten","NameNeu",true
	FF_EnableControl "Web-Schatten","Zielordner",true
	FF_EnableControl "Web-Schatten","...",true
end if

if flag_WebAblage = 0 then
	FF_EnableControl "Web-Schatten","flag_LinkSpeichern", false
	FF_EnableControl "Web-Schatten","flag_LinkVBcode", false
else
	FF_EnableControl "Web-Schatten","flag_LinkSpeichern", true
	FF_EnableControl "Web-Schatten","flag_LinkVBcode", true
end if

if flag_shdParam = 0 then
	FF_EnableControl "Web-Schatten","SchLage", false
	FF_EnableControl "Web-Schatten","SchStaerke", false
	FF_EnableControl "Web-Schatten","SchFarbe", false
	FF_EnableControl "Web-Schatten","UnschFaktor", false
	FF_EnableControl "Web-Schatten","HGdFarbe", false
	FF_EnableControl "Web-Schatten","HgErw", false
	FF_EnableControl "Web-Schatten","= HGF", false
	FF_EnableControl "Web-Schatten","flag_HGmin", false
else
	FF_EnableControl "Web-Schatten","SchLage", true
	FF_EnableControl "Web-Schatten","SchStaerke", true
	FF_EnableControl "Web-Schatten","SchStaerke", true
	FF_EnableControl "Web-Schatten","SchFarbe", true
	FF_EnableControl "Web-Schatten","UnschFaktor", true
	FF_EnableControl "Web-Schatten","HGdFarbe", true
	if flag_HGmin = 1 then
		FF_EnableControl "Web-Schatten","HgErw", false
	else
		FF_EnableControl "Web-Schatten","HgErw", true
	end if
	FF_EnableControl "Web-Schatten","= HGF", true
	if SchLage <> "rundherum" then
		FF_EnableControl "Web-Schatten","flag_HGmin", true
	else
		FF_EnableControl "Web-Schatten","flag_HGmin", false
	end if
end if

if flag_shdParam_I = 0 then
	FF_EnableControl "Web-Schatten","SchLage_I", false
	FF_EnableControl "Web-Schatten","SchStaerke_I", false
	FF_EnableControl "Web-Schatten","SchTrans_I", false
	FF_EnableControl "Web-Schatten","UnschFaktor_I", false
	FF_EnableControl "Web-Schatten","SchFarbe_I", false
else
	FF_EnableControl "Web-Schatten","SchLage_I", true
	FF_EnableControl "Web-Schatten","SchStaerke_I",true
	FF_EnableControl "Web-Schatten","SchTrans_I",true
	FF_EnableControl "Web-Schatten","UnschFaktor_I",true
	FF_EnableControl "Web-Schatten","SchFarbe_I", true
end if

	Abbruch = false
	Select Case FF_ShowDialog ("Web-Schatten")
	
	Case "TIMER"
		FF_SetControl "Web-Schatten" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Web-Schatten", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			Abbruch = true
			exit do
		end if
	Case "selAB"		'Auswahl aktives Bild
		Auswahl = 4
		FF_SetControl "Web-Schatten","selAB",1
		FF_SetControl "Web-Schatten","selCV",0
		FF_SetControl "Web-Schatten","selBL",0
	Case "selCV"		'Auswahl markierte in der Comp.-Ansicht
		Auswahl = 1
		FF_SetControl "Web-Schatten","selAB",0
		FF_SetControl "Web-Schatten","selCV",1
		FF_SetControl "Web-Schatten","selBL",0
	Case "selBL"		'Auswahl markierte in der aktuellen Bilderliste
		Auswahl = 3
		FF_SetControl "Web-Schatten","selAB",0
		FF_SetControl "Web-Schatten","selCV",0
		FF_SetControl "Web-Schatten","selBL",1
	Case "flag_WebAblage"
		flag_WebAblage = FF_GetControl("Web-Schatten","flag_WebAblage")
	Case "..."
		FF_SetCurrentPath Zielordner
		Zielordner = FF_EnterPath(false,"Wahl des Ablageordners")
		if len(Zielordner) > 2 then FF_SetControl "Web-Schatten","Zielordner",Zielordner
		if Version_OK("3.30.06") then
			FF_SetControlTooltip "Web-Schatten","Zielordner",Zielordner
		end if
	Case "FTP-Zugangsdaten"
		call FTP_Dialog
	Case "flag_shdParam"
		flag_shdParam = FF_GetControl("Web-Schatten","flag_shdParam")
	Case "SchLage"
		SchLage = FF_GetControl("Web-Schatten","SchLage")
	Case "flag_HGmin"
		flag_HGmin = FF_GetControl("Web-Schatten","flag_HGmin")
	Case "= HGF"
		FF_SetControl "Web-Schatten","RdFarbe",FF_GetControl("Web-Schatten","HGdFarbe")
	Case "flag_shdParam_I"
		flag_shdParam_I = FF_GetControl("Web-Schatten","flag_shdParam_I")
	Case "SchLage_I"
		SchLage_I = FF_GetControl("Web-Schatten","SchLage_I")
	Case "FF-Forenwerte"
		FF_SetControl "Web-Schatten","lSeite",FFF_lSeite
		FF_SetControl "Web-Schatten","HGdFarbe",FFF_HGdFarbe
	Case "?"
		'FF_SetControl "Web-Schatten","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\WebSchatten\WebSchatten.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht geffnet werden." & vbNewLine & _
				   "Mglicherweise wurde die PDF-Datei gelscht oder" & vbNewLine & _
				   "es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error goto 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "flag_Protokoll"
		if FF_GetControl("Web-Schatten","flag_Protokoll") = 1 then
			msgbox "Am Ende der Bearbeitung wird zuknftig ein" & vbNewLine & _
				   "kurzes Protokoll angezeigt.",vbInformation,"Hinweis"
		else
			msgbox "Zuknftig wird am Ende der Bearbeitung" & vbNewLine & _
				   "kein Protokoll mehr angezeigt.",vbInformation,"Hinweis"
		end if
	Case "flag_DimmerEin"
		if FF_GetControl("Web-Schatten","flag_DimmerEin") = 1 then
			msgbox "Der vorliegende Dialog wird zuknftig immer angezeigt, auch wenn die" & vbNewLine & _
				   "Auswahl 'aktives Bild auf der Arbeitsflche' aktiviert ist.",vbInformation,"Hinweis"
		else
			msgbox "Der vorliegende Dialog wird zuknftig nicht mehr angezeigt, wenn die" & vbNewLine & _
				   "Auswahl 'aktives Bild auf der Arbeitsflche' aktiviert ist." & vbNewLine & vbNewLine & _
				   "Soll er trotzdem aufgerufen werden, ist dies durch Start des Skripts" & vbNewLine & _
				   "durch Doppelklick bei festgehaltener Shift-Taste mglich.",vbInformation,"Hinweis"
		end if
	Case "OK"
		call RegistrySchreiben
		'Bilder vorhanden?
		if Auswahl < 4 then Bilder = FF_GetSelection(Auswahl) else Bilder = FF_GetImageName(-1)
		if len(Bilder) = 0 then
			msgbox "Es ist kein Bild markiert bzw. geladen!",vbExclamation,"Meldung"
			exit do
		end if
		call Kontrolle
		if not Abbruch then
			call Bildschleife
			if not Abbruch then exit do
		end if
	Case "CANCEL","Abbrechen"
		call RegistrySchreiben
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Web-Schatten")
if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 1
if Auswahl = 4 then Bilder = FF_GetImageName(-1)

'Speicheroptionen
flag_Schaerfen = FF_GetProfile (RegSchluessel,"flag_Schaerfen")
if flag_Schaerfen = "" then flag_Schaerfen = 1

SchaerfeWert = FF_GetProfile (RegSchluessel,"SchaerfeWert")
if SchaerfeWert = "" then SchaerfeWert = "mittel"

flag_EI_loeschen = FF_GetProfile (RegSchluessel,"flag_EI_loeschen")
if flag_EI_loeschen = "" then flag_EI_loeschen = 1

flag_NurVerkleinern = FF_GetProfile (RegSchluessel,"flag_NurVerkleinern")
if flag_NurVerkleinern = "" then flag_NurVerkleinern = 1

'Umbenennung
flag_Umbenennen = FF_GetProfile (RegSchluessel,"flag_Umbenennen")
if flag_Umbenennen = "" then flag_Umbenennen = 0

NameNeu = FF_GetProfile (RegSchluessel,"NameNeu")
if NameNeu = "" then NameNeu = "Bildname"

'Speicherqualitt
Qualitaet = FF_GetProfile (RegSchluessel,"Qualitaet")
if Qualitaet = "" then Qualitaet = 80

'Speicherort
Zielordner = FF_GetProfile (RegSchluessel,"Zielordner")
if not fso.FolderExists(Zielordner) then Zielordner = FF_GetImagePath

'Webablage
flag_WebAblage = FF_GetProfile (RegSchluessel,"flag_WebAblage")
if flag_WebAblage = "" then flag_WebAblage = 0

flag_LinkSpeichern = FF_GetProfile (RegSchluessel,"flag_LinkSpeichern")
if flag_LinkSpeichern = "" then flag_LinkSpeichern = 1

flag_LinkVBcode = FF_GetProfile (RegSchluessel,"flag_LinkVBcode")
if flag_LinkVBcode = "" then flag_LinkVBcode = 1

'Bildgre und Schattenwerte auslesen
lSeite = FF_GetProfile (RegSchluessel,"lSeite")				'px = lngste Seite
if lSeite = "" then lSeite = FFF_lSeite
UR_lSeite = lSeite

flag_shdParam = FF_GetProfile (RegSchluessel,"flag_shdParam")	'Schattenbildung auen ein/aus
if flag_shdParam = "" then flag_shdParam = 1

SchLage = FF_GetProfile (RegSchluessel,"SchLage")			'Schattenlage auen
if SchLage = "" then SchLage = "unten rechts"

SchStaerke = FF_GetProfile (RegSchluessel,"SchStaerke")		'o/o  = Schattenstrke auen
if SchStaerke = "" then SchStaerke = 8

SchFarbe = FF_GetProfile (RegSchluessel,"SchFarbe")			'Schattenfarbe Dunkelgrau auen
if SchFarbe = "" then SchFarbe = "075 075 075"

HGdFarbe = FF_GetProfile (RegSchluessel,"HGdFarbe")			'Hintergrundfarbe Forenwei auen
if HGdFarbe = "" then HGdFarbe = FFF_HGdFarbe

HgErw = FF_GetProfile (RegSchluessel,"HgErw")				'Hintergrunderweiterung in Promille auen
if HgErw = "" then HgErw = 0

UnschFaktor = FF_GetProfile (RegSchluessel,"UnschFaktor")	'Unschrfefaktor auen
if UnschFaktor = "" then UnschFaktor = 3


flag_shdParam_I = FF_GetProfile (RegSchluessel,"flag_shdParam_I")	'Schattenbildung innen ein/aus
if flag_shdParam_I = "" then flag_shdParam_I = 0

SchLage_I = FF_GetProfile (RegSchluessel,"SchLage_I")				'Schattenlage innen
if SchLage_I = "" then SchLage_I = "oben links"

SchStaerke_I = FF_GetProfile (RegSchluessel,"SchStaerke_I")			'o/o  = Schattenstrke innen
if SchStaerke_I = "" then SchStaerke_I = 4

SchTrans_I = FF_GetProfile (RegSchluessel,"SchTrans_I")				'Schattentransparenz innen
if SchTrans_I = "" then SchTrans_I = 1

UnschFaktor_I = FF_GetProfile (RegSchluessel,"UnschFaktor_I")		'Unschrfefaktor innen
if UnschFaktor_I = "" then UnschFaktor_I = 4

SchFarbe_I = FF_GetProfile (RegSchluessel,"SchFarbe_I")				'Schattenfarbe schwarz innen
if SchFarbe_I = "" then SchFarbe_I = "000 000 000"


RandStaerke = FF_GetProfile (RegSchluessel,"RandStaerke")	'o/oo = Randstrke fr Bilderweiterung in Hintergrundfarbe
if RandStaerke = "" then RandStaerke = 2

RdFarbe = FF_GetProfile (RegSchluessel,"RdFarbe")			'Randfarbe
if RdFarbe = "" then RdFarbe = FFF_HGdFarbe

flag_HGmin = FF_GetProfile (RegSchluessel,"flag_HGmin")		'Hintergrund minimieren
if flag_HGmin = "" then flag_HGmin = 0

flag_Protokoll = FF_GetProfile (RegSchluessel,"flag_Protokoll")	'Protokollanzeige
if flag_Protokoll = "" then flag_Protokoll = 1

flag_DimmerEin = FF_GetProfile (RegSchluessel,"flag_DimmerEin")	'Dialog immer Ein
if flag_DimmerEin = "" then flag_DimmerEin = 1

End Sub

'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
'Auswahl
if FF_GetControl ("Web-Schatten","selCV") = 1 then Auswahl = 1	'markierte Dateien der Computeransicht
if FF_GetControl ("Web-Schatten","selBL") = 1 then Auswahl = 3	'markierte Dateien der aktuellen Bilderliste
if FF_GetControl ("Web-Schatten","selAB") = 1 then Auswahl = 4	'aktives Bild auf der Arbeitsflche

'Speicheroptionen
flag_Schaerfen = FF_GetControl("Web-Schatten","flag_Schaerfen")
SchaerfeWert = FF_GetControl("Web-Schatten","SchaerfeWert")
flag_EI_loeschen = FF_GetControl("Web-Schatten","flag_EI_loeschen")
flag_NurVerkleinern = FF_GetControl("Web-Schatten","flag_NurVerkleinern")

'Neuer Name
flag_Umbenennen = FF_GetControl("Web-Schatten","flag_Umbenennen")
NameNeu = FF_GetControl("Web-Schatten","NameNeu")

'Speicherqualitt
Qualitaet = FF_GetControl("Web-Schatten","Qualitaet")

'Speicherort
Zielordner = FF_GetControl("Web-Schatten","Zielordner")

'Webablage
flag_WebAblage = FF_GetControl("Web-Schatten","flag_WebAblage")
flag_LinkSpeichern = FF_GetControl("Web-Schatten","flag_LinkSpeichern")
flag_LinkVBcode = FF_GetControl("Web-Schatten","flag_LinkVBcode")

'Bildgre und Schattenparameter
lSeite = FF_GetControl("Web-Schatten","lSeite")
UR_lSeite = lSeite
flag_shdParam = FF_GetControl("Web-Schatten","flag_shdParam")
SchLage = FF_GetControl("Web-Schatten","SchLage")
SchStaerke = FF_GetControl("Web-Schatten","SchStaerke")
SchFarbe = FF_GetControl("Web-Schatten","SchFarbe")
HGdFarbe = FF_GetControl("Web-Schatten","HGdFarbe")
HgErw = FF_GetControl("Web-Schatten","HgErw")
UnschFaktor = FF_GetControl("Web-Schatten","UnschFaktor")
RandStaerke = FF_GetControl("Web-Schatten","RandStaerke")
RdFarbe = FF_GetControl("Web-Schatten","RdFarbe")
flag_HGmin = FF_GetControl("Web-Schatten","flag_HGmin")

flag_shdParam_I = FF_GetControl("Web-Schatten","flag_shdParam_I")
SchLage_I = FF_GetControl("Web-Schatten","SchLage_I")
SchStaerke_I = FF_GetControl("Web-Schatten","SchStaerke_I")
SchTrans_I = FF_GetControl("Web-Schatten","SchTrans_I")
UnschFaktor_I = FF_GetControl("Web-Schatten","UnschFaktor_I")
SchFarbe_I = FF_GetControl("Web-Schatten","SchFarbe_I")

'Allgemein
flag_Protokoll = FF_GetControl("Web-Schatten","flag_Protokoll")
flag_DimmerEin = FF_GetControl("Web-Schatten","flag_DimmerEin")

'Werte schreiben
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl
FF_WriteProfile RegSchluessel,"flag_Schaerfen",flag_Schaerfen
FF_WriteProfile RegSchluessel,"SchaerfeWert",SchaerfeWert
FF_WriteProfile RegSchluessel,"flag_EI_loeschen",flag_EI_loeschen
FF_WriteProfile RegSchluessel,"flag_NurVerkleinern",flag_NurVerkleinern
FF_WriteProfile RegSchluessel,"flag_Umbenennen",flag_Umbenennen
FF_WriteProfile RegSchluessel,"NameNeu",NameNeu
FF_WriteProfile RegSchluessel,"Qualitaet",Qualitaet
FF_WriteProfile RegSchluessel,"Zielordner",Zielordner
FF_WriteProfile RegSchluessel,"flag_WebAblage",flag_WebAblage
FF_WriteProfile RegSchluessel,"flag_LinkSpeichern",flag_LinkSpeichern
FF_WriteProfile RegSchluessel,"flag_LinkVBcode",flag_LinkVBcode
FF_WriteProfile RegSchluessel,"lSeite",lSeite

FF_WriteProfile RegSchluessel,"flag_shdParam",flag_shdParam
FF_WriteProfile RegSchluessel,"SchLage",SchLage
FF_WriteProfile RegSchluessel,"SchStaerke",SchStaerke
FF_WriteProfile RegSchluessel,"SchFarbe",SchFarbe
FF_WriteProfile RegSchluessel,"HGdFarbe",HGdFarbe
FF_WriteProfile RegSchluessel,"HgErw",HgErw
FF_WriteProfile RegSchluessel,"UnschFaktor",UnschFaktor

FF_WriteProfile RegSchluessel,"flag_shdParam_I",flag_shdParam_I
FF_WriteProfile RegSchluessel,"SchLage_I",SchLage_I
FF_WriteProfile RegSchluessel,"SchStaerke_I",SchStaerke_I
FF_WriteProfile RegSchluessel,"SchTrans_I",SchTrans_I
FF_WriteProfile RegSchluessel,"UnschFaktor_I",UnschFaktor_I
FF_WriteProfile RegSchluessel,"SchFarbe_I",SchFarbe_I

FF_WriteProfile RegSchluessel,"RandStaerke",RandStaerke
FF_WriteProfile RegSchluessel,"RdFarbe",RdFarbe
FF_WriteProfile RegSchluessel,"flag_HGmin",flag_HGmin
FF_WriteProfile RegSchluessel,"flag_Protokoll",flag_Protokoll
FF_WriteProfile RegSchluessel,"flag_DimmerEin",flag_DimmerEin

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\\FixFotoScript.ini"

if fso.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & fso.GetBaseName(Skriptname) & ".zip"
if fso.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & fso.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			Abbruch = true
			exit sub
		end if
		SPfad = SPfad & "\" & fso.GetBaseName(Skriptname) & ".zip"
		fso.CopyFile Tempfile, SPfad, true
	end if
	fso.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
fso.DeleteFile TempFile,true

'### beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\WebSchatten\TempBild.jpg"
'if fso.FileExists(TempFile) then fso.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\WebSchatten"
if fso.FolderExists(TempFile) then fso.DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"

'und ggf. Registrydaten fr die FTP-Zugangsdaten lschen
Antwort = msgbox("Sollen auch die Registrydaten zum FTP-Zugang gelscht werden?" & vbNewline & _
		 		 "Sie werden evtl. auch fr andere Skripte verwendet!",vbYesNo + vbQuestion,"Sicherheitsabfrage")
if Antwort = vbYes then
	TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & FTP_RegSchluessel & "\"
	WshShell.RegDelete(TempFile)
end if

'### Fertigmeldung
msgbox "Das Skript " & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung
Abbruch = false

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = fso.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr

	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = fso.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = fso.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
fso.CopyFile DateiTmp, TempFile, True
fso.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

'Versionstest fr Auswahl
if Auswahl = 3 then		'Auswahl aktiver Bilderliste
	if not Version_OK("2.90.0") then
		msgbox "Um die Auswahl aktiver Bilderlisten nutzen zu knnen" & vbNewLine & _
			   "ist mindestens FixFoto-Version 2.90 erforderlich.",vbCritical,"Hinweis"
		Abbruch = true : exit sub
	end if
end if

'Versionstest fr Linkbernahme in die Zwischenablage bei Webablage
if flag_WebAblage = 1 and flag_LinkSpeichern = 1 then
	if not Version_OK("3.10.0") then
		msgbox "Um Links in die Zwischenablage bernhmen zu knnen," & vbNewLine & _
			   "ist mindestens FixFoto-Version 3.10 erforderlich.",vbCritical,"Hinweis"
		Abbruch = true : exit sub
	end if
end if

'Seitenlnge
if lSeite = "" then lSeite = 0
if lSeite < 100 then
	msgbox "Die Seitenlnge muss mindestens 100 px betragen!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

'Speicherqualitt
if Qualitaet = "" then Qualitaet = 10 'nicht zugelassene Qualit
if Qualitaet <> 0 and (Qualitaet < 60 or Qualitaet > 100) then
	msgbox "Die Speicherqualitt muss 0 sein" & vbNewLine & "oder zwischen 60 % und 100 % betragen!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

'Speicherort
if Zielordner = "" then
	msgbox "Achtung: Es muss ein Zielordner angegeben werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if not fso.FolderExists(Zielordner) then
	msgbox "Das Verzeichnis" & vbNewLine & Zielordner & vbNewLine & "als Speicherort existiert nicht." & vbNewLine & _
		   "Es muss neu angelegt werden!",vbExclamation,"Meldung"
	FF_SetControl "Web-Schatten","Zielordner",""
	Abbruch = true : exit sub
end if

'Umbenennung
if flag_Umbenennen = 1 and NameNeu = "" then
	msgbox "Fr die Umbenennung wurde kein Name eingegeben!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

'Hintergrunderweiterung
if (HgErw * 1) > 400 then
	msgbox "Die Hintergrunderweiterung darf max. 400  betragen!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
'########### FTP-Funktion ###############
'------------------------------------------------------------------------
Sub FTP_Oeffnen
Dim path

'### Werteprfung
if len(server) = 0 or len(remotepath) = 0 or len(user) = 0 then
	msgbox "Es mssen mindestens Werte fr" & vbNewLine & _
		   "den FTP-Server, den Serverpfad und den Benutzernamen" & vbNewLine & _
		   "eingegeben werden!",vbExclamation,"Hinweis"
	call FTP_Dialog
	Abbruch = true : exit sub
end if

'### Passwortprfung
if len(pwd) = 0 then
	pwd = trim(inputbox("Passwort?","Eingabeaufforderung"))
	if len(pwd) = 0 then
		msgbox "Es wurde kein Passwort eingegeben!",,vbExclamation,"Hinweis"
		Abbruch = true : exit sub
	end if
end if

'### FTP-Verbindung ffnen und Serverpfad prfen, ggf anlegen
if FF_OpenFTP(server,user,pwd,bool_pFTP) = false then		'FTP-Verbindung ffnen
	Abbruch = true : exit sub
end if

if FF_SetCurrentFTPDir("/" & remotepath) = false then		'Test ob gewnschtes Verz. vorhanden
	Antwort = msgbox("Der Serverpfad '" & remotepath & "'" & vbNewLine & _
					 "existiert nicht!" & vbNewLine & _
					 "Soll er angelegt werden?",vbYesNo + vbQuestion,"Abfrage")
	if Antwort = vbNo then
		FF_CloseFTP()
		Abbruch = true : exit sub
	else
		if FF_CreateFTPDir("/" & remotepath) = false then				'ggf. Verzeichnis anlegen
			Array = split(remotepath,"/")
			for each element in Array
				path = path & "/" & element
				if FF_SetCurrentFTPDir(path) = false then
					if FF_CreateFTPDir(path) = false then
						msgbox "Der Serverpfad '" & remotepath & _
						"' konnte nicht angelegt werden",vbExclamation,"Abbruch"
						FF_CloseFTP()
						exit sub
					end if
				end if
			next			
		end if
		if FF_SetCurrentFTPDir("/" & remotepath) = false then
			msgbox "Der Serverpfad '" & remotepath & _
				   "' konnte nicht angelegt werden",vbExclamation,"Abbruch"
			FF_CloseFTP()
			exit sub
		end if
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub FTP_Uebertragung(file)
'### Testen ob Bild bereits auf dem Server existiert
Dim Link_Temp

if Auswahl = 4 then
	file = FF_GetScriptPath & "\MeckiScript\WebSchatten\TempBild.jpg"	'Bild sichern
	FF_SaveImage file,0
	FTP_file = fso.GetBaseName(FF_GetImageName(-1)) & shd_Suffix & strExtension
else
	FTP_file = fso.GetFileName(file)
end if

if FF_FTPFileExists(FTP_file) then							'Sicherheitsabfrage wenn Bild vorhanden
	Antwort = msgbox("Das Bild '" & FTP_file & "' ist bereits" & vbNewLine & _
					 "im Webpfad '" & remotepath & "' abgelegt." & vbNewLine & vbNewLine & _
					 "Soll es berschrieben werden?",vbYesNoCancel + vbQuestion,"Abfrage")
	if Antwort = vbNo then exit sub
	if Antwort = vbCancel then
		FTP_Abbruch = true
		FF_CloseFTP()
		exit sub
	end if
end if

'### Bild auf dem Server ablegen und den Link in die Zwischenablage bernehmen
if FF_WriteFTPFile(file,FTP_file) then			'Bild auf dem Server ablegen
	Anz_web = Anz_web +1
	if len(domain) > 0 and flag_LinkSpeichern = 1 then
		if flag_LinkVBcode = 1 Then
			Link_Temp = "[img]" & domain & "/" & remotepath & "/" & FTP_file & "[/img]"
		else
			Link_Temp = domain & "/" & remotepath & "/" & FTP_file
		end if
		Anz_lks = Anz_lks +1
		if len(FTP_Links) = 0 then
			FTP_Links = Link_Temp
		else
			FTP_Links = FTP_Links & vbNewLine & Link_Temp
		end if
	end if
else
	msgbox "Bei der FTP-bertragung ist ein Fehler aufgetreten!",vbExclamation,"Abbruch"
end if

End Sub
'---------------------------------------------------------------------
Sub FTP_Dialog

'** Start Dialog FTP-Zugang **
FF_AddDialog "FTP-Zugang",160,102
FF_AddControl "FTP-Zugang","FTP-Server","STATIC",5,5,40,10
FF_AddControl "FTP-Zugang","server","SLEDIT",50,5,105,10
FF_AddControl "FTP-Zugang","Serverpfad","STATIC",5,15,40,10
FF_AddControl "FTP-Zugang","remotepath","SLEDIT",50,15,105,10
FF_AddControl "FTP-Zugang","Domainname","STATIC",5,25,40,10
FF_AddControl "FTP-Zugang","domain","SLEDIT",50,25,105,10
FF_AddControl "FTP-Zugang","Benutzername","STATIC",5,35,40,10
FF_AddControl "FTP-Zugang","user","SLEDIT",50,35,105,10
FF_AddControl "FTP-Zugang","Passwort","STATIC",5,45,40,10
FF_AddControl "FTP-Zugang","pwd","SLEDIT",50,45,105,10
FF_SetControlStyle "FTP-Zugang","pwd",32
FF_AddControl "FTP-Zugang","Passiv FTP","STATIC",15,68,28,10
FF_AddControl "FTP-Zugang","passiveftp","BOOL",4,69,8,8
FF_AddControl "FTP-Zugang","Ist kein Passwort eingegeben, wird es jeweils abgefragt.","STATIC",5,56,150,8
FF_AddControl "FTP-Zugang","?","BUTTON",12,86,11,11
FF_AddControl "FTP-Zugang","bernehmen","BUTTON",110,86,38,11
FF_AddControl "FTP-Zugang","FixFoto-Daten eintragen","BUTTON",50,68,105,10
FF_AddControl "FTP-Zugang","Abbrechen","BUTTON",57,86,38,11
'** End Dialog FTP-Zugang **

'### Werte in Dialog eintragen
FF_SetControl "FTP-Zugang","server",server
FF_SetControl "FTP-Zugang","remotepath",remotepath
FF_SetControl "FTP-Zugang","domain",domain
FF_SetControl "FTP-Zugang","user",user
FF_SetControl "FTP-Zugang","pwd",pwd
FF_SetControl "FTP-Zugang","passiveftp",passiveftp

'### Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "FTP-Zugang","FixFoto-Daten eintragen", "" &_
						 "Die FTP-Daten aus den Optionen des" & vbNewLine & _
						 "Speicherdialogs werden eingetragen."
end if

do
	Select Case FF_ShowDialog ("FTP-Zugang")
	Case "FixFoto-Daten eintragen"
		call FF_FTP_Daten
	Case "?"
		msgbox 	"- FTP-Server (unbedingt notwendig)" & vbNewLine & _
				"FTP-Adresse des Webservers (z.B. meineseite.de)" & vbNewLine & _ 
				"Ein Proxyserver kann nicht angesprochen werden."& vbNewLine & vbNewLine & _
				"- Serverpfad (unbedingt notwendig)" & vbNewLine & _
				"Verzeichnis in das die Bilder abgelegt werden sollen" & vbNewLine & _
				"(z.B. bilder oder auch bilder/privat)" & vbNewLine & _
				"Existiert das Verzeichnis nicht, wird es auf Wunsch angelegt." & vbNewLine & vbNewLine & _
				"- Domainname" & vbNewLine & _
				"URL des Webspaces (z.B. http://www.meineseite.de)" & vbNewLine & _
				"Er wird nur zur Erzeugung eines Link auf das abgelegte Bild bentigt."& vbNewLine & vbNewLine & _
				"- Benutzername (unbedingt notwendig)" & vbNewLine & _
				"Benutzername zum Einloggen auf dem FTP-Server" & vbNewLine & vbNewline & _
				"- Passwort" & vbNewLine & _
				"Passwort zum Einloggen auf dem FTP-Server." & vbNewLine & _
				"Wird kein Passwort eingegeben, wird es jeweils abgefragt." & vbNewLine & vbNewLine & _
				"- Passiv-FTP" & vbNewLine & _
				"Wird eine Firewall benutzt, ist dieses Kstchen anzuhaken, falls" & vbNewLine & _
				"die FTP-Verbindung nicht zustande kommt." & vbNewLine & vbNewLine & _
				"Weitere Informationen sind der Kurzbeschreibung zu entnehmen.",vbInformation,"Erluterung zum FTP-Zugang"
	Case "bernehmen"
		call FTP_RegistrySchreiben
		exit do
	Case "Abbrechen","CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("FTP-Zugang")

End Sub
'-------------------------------------------------------------------
Sub FTP_RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & FTP_RegSchluessel

'### Werte aus Registry auslesen
server = FF_GetProfile (FTP_RegSchluessel,"server")
remotepath = FF_GetProfile (FTP_RegSchluessel,"remotepath")
domain = FF_GetProfile (FTP_RegSchluessel,"domain")
user = FF_GetProfile (FTP_RegSchluessel,"user")
pwd = FF_GetProfile (FTP_RegSchluessel,"pwd")
passiveftp = FF_GetProfile (FTP_RegSchluessel,"passiveftp")
if passiveftp = "" then passiveftp = 0
if passiveftp = 0 then bool_pFTP = false else bool_pFTP = true

End Sub
'---------------------------------------------------------------------
Sub FTP_RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & FTP_RegSchluessel

'### Werte aus Dialog auslesen
server = trim(FF_GetControl("FTP-Zugang","server"))
remotepath = trim(FF_GetControl("FTP-Zugang","remotepath"))
if remotepath = "/" then remotepath = ""
do
	if left(remotepath,1) = "/" and len(remotepath) > 1 then
		remotepath = mid(remotepath,2)
	else
		exit do
	end if
loop

do
	if right(remotepath,1) = "/" and len(remotepath) > 1 then
		remotepath = left(remotepath,len(remotepath)-1)
	else
		exit do
	end if
loop

domain = trim(FF_GetControl("FTP-Zugang","domain"))
user = trim(FF_GetControl("FTP-Zugang","user"))
pwd = trim(FF_GetControl("FTP-Zugang","pwd"))
passiveftp = trim(FF_GetControl("FTP-Zugang","passiveftp"))
if passiveftp = 0 then bool_pFTP = false else bool_pFTP = true

'### Werte in Registry schreiben
FF_WriteProfile FTP_RegSchluessel,"server",server
FF_WriteProfile FTP_RegSchluessel,"remotepath",remotepath
FF_WriteProfile FTP_RegSchluessel,"domain",domain
FF_WriteProfile FTP_RegSchluessel,"user",user
FF_WriteProfile FTP_RegSchluessel,"pwd",pwd
FF_WriteProfile FTP_RegSchluessel,"passiveftp",passiveftp

End Sub
'---------------------------------------------------------------------
Sub FF_FTP_Daten

'### FF_FTP_Daten aus der Registry auslesen
'const FF_FTP_Reg = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\"
const FF_FTP_Reg = "HKCU\Software\Joachim Koopmann Software\FixFoto\Options\"
Dim server_temp,remotepath_temp,domain_temp,user_temp,pwd_temp,passiveftp_temp
Dim FTP_Daten_Temp

On Error Resume Next

server_temp = WshShell.RegRead (FF_FTP_Reg & "FTPServer")
FTP_Daten_Temp = server_temp & "|"
remotepath_temp = WshShell.RegRead (FF_FTP_Reg & "FTPPath")
FTP_Daten_Temp = FTP_Daten_Temp & remotepath_temp & "|"
domain_temp = WshShell.RegRead (FF_FTP_Reg & "FTPDPath")
FTP_Daten_Temp = FTP_Daten_Temp & domain_temp & "|"
user_temp = WshShell.RegRead (FF_FTP_Reg & "FTPUser")
FTP_Daten_Temp = FTP_Daten_Temp & user_temp & "|"
pwd_temp = WshShell.RegRead (FF_FTP_Reg & "FTPPwd")
FTP_Daten_Temp = FTP_Daten_Temp & pwd_temp & "|"
passiveftp_temp = WshShell.RegRead (FF_FTP_Reg & "PassiveFTP")
FTP_Daten_Temp = FTP_Daten_Temp & passiveftp_temp

Err.Clear
On Error GoTo 0

if len(FTP_Daten_Temp) = 0 then
	msgbox "Es wurden keine FTP-Daten in den" & vbNewLine & _
		   "Optionen des Speicherdialogs gefunden!",vbInformation,"Hinweis"
	exit sub
end if

'### FF_FTP_Daten eintragen
FF_SetControl "FTP-Zugang","server",server_temp
FF_SetControl "FTP-Zugang","remotepath",remotepath_temp
FF_SetControl "FTP-Zugang","domain",domain_temp
FF_SetControl "FTP-Zugang","user",user_temp
FF_SetControl "FTP-Zugang","pwd",pwd_temp
FF_SetControl "FTP-Zugang","passiveftp",passiveftp_temp

End Sub
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------